<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 10/07/2004 *
 * ===================                          Last change: 10/07/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-transfer.php                                *
 * -------------------------------------------------------------------- *
 * Short description : Point transfers                                  *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Punktetransfers                                  *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009, 2010 by Mailer Developer Team                    *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} elseif (!isMember()) {
	redirectToIndexMemberOnlyModule();
}

// Add description as navigation point
addMenuDescription('member', __FILE__);

if ((!isExtensionActive('transfer')) && (!isAdmin())) {
	loadTemplate('admin_settings_saved', false, generateExtensionInactiveNotInstalledMessage('transfer'));
	return;
} // END - if

// Check for mode in GET
$mode = '';
if (isGetRequestParameterSet('mode')) $mode = getRequestParameter('mode');

// Check for "faker"
if ((getUserData('opt_in') != 'Y') && ($mode == 'new')) $mode = '';

switch ($mode) {
	case 'new': // Start new transfer
		// Get total points and subtract the balance amount from it = maximum transferable points
		$total = getTotalPoints(getMemberId());

		// Remember maximum value for template
		$content['max_transferable'] = round($total - getConfig('transfer_balance') - 0.5);

		if (isFormSent()) {
			// Add new transfer
			if (getConfig('transfer_code') > 0) {
				// Check for code
				$code = generateRandomCode(getConfig('transfer_code'), postRequestParameter('code_chk'), getMemberId(), $content['max_transferable']);
				$valid_code = ($code == postRequestParameter('code'));
			} else {
				// Zero length (= disabled) is always valid!
				$valid_code = true;
			}

			// Test password
			$valid_pass = ($pass == generateHash(postRequestParameter('password'), $pass));

			// Test transfer amount
			$valid_amount = ((isPostRequestParameterSet('points')) && (postRequestParameter('points') <= $content['max_transferable']));

			// Test reason for transfer
			$valid_reason = (isPostRequestParameterSet('reason'));

			// Test if a recipient is selected
			$valid_recipient = isValidUserId(postRequestParameter('to_userid'));

			// Check for nickname extension and set additional data
			// @TODO Rewrite this to a filter
			$add = '';
			if (isExtensionActive('nickname')) {
				$add = ', `nickname`';
			} // END - if

			// Re-check receivers and own personal data
			$result = SQL_QUERY_ESC("SELECT `userid`, `gender`, `surname`, `family`, `email`".$add." FROM `{?_MYSQL_PREFIX?}_user_data` WHERE `userid` IN ('%s','%s') AND `status`='CONFIRMED' LIMIT 2",
				array(
					getMemberId(),
					bigintval(postRequestParameter('to_userid'))
				), __FILE__, __LINE__);

			// Do we have two entries?
			$valid_data = (SQL_NUMROWS($result) == 2);

			// Final check if all is fine
			if ($valid_code && $valid_data && $valid_pass && $valid_amount && $valid_reason && $valid_recipient) {
				// Let's start the transfer and load user data
				$content['sender']    = SQL_FETCHARRAY($result);
				$content['recipient'] = SQL_FETCHARRAY($result);

				// Is the nickname extension not installed?
				if (!isExtensionActive('nickname')) {
					// Fix empty nicknames
					$content['sender']['nickname']    = '';
					$content['recipient']['nickname'] = '';
				} // END - if

				// Prepare variables for testing
				$TEST_NICK_SENDER = $content['sender']['nickname'];
				$TEST_NICK_REC    = $content['recipient']['nickname'];

				// Default is userids for subject line
				$SENDER = getMemberId();
				$RECIPIENT = bigintval(postRequestParameter('to_userid'));

				// If nickname is installed we can set the nickname
				// @TODO Rewrite this to a filter
				if (isExtensionActive('nickname')) {
					if (($TEST_NICK_SENDER != getMemberId()) && (!empty($TEST_NICK_SENDER))) {
						$SENDER = $content['sender']['nickname'];
					}

					if (($TEST_NICK_REC != postRequestParameter('to_userid')) && (!empty($TEST_NICK_REC))) {
						$RECIPIENT = $content['recipient']['nickname'];
					}
				} // END - if

				// Remember transfer reason and fancy date/time in constants
				$content['reason']  = secureString(postRequestParameter('reason'));
				$content['expires'] = createFancyTime(getConfig('transfer_age'));

				// Generate tranafer id
				$content['trans_id'] = bigintval(generateRandomCode('10', mt_rand(0, 99999), getMemberId(), postRequestParameter('reason')));

				// Add entries to both tables
				SQL_QUERY_ESC("INSERT INTO `{?_MYSQL_PREFIX?}_user_transfers_in` (`userid`, `from_userid`, `points`, `reason`, `time_trans`, `trans_id`) VALUES ('%s','%s','%s','%s', UNIX_TIMESTAMP(),'%s')",
					array(bigintval(postRequestParameter('to_userid')), getMemberId(), bigintval(postRequestParameter('points')), postRequestParameter('reason'), $content['trans_id']), __FILE__, __LINE__);
				SQL_QUERY_ESC("INSERT INTO `{?_MYSQL_PREFIX?}_user_transfers_out` (`userid`, `to_userid`, `points`, `reason`, `time_trans`, `trans_id`) VALUES ('%s','%s','%s','%s', UNIX_TIMESTAMP(),'%s')",
					array(getMemberId(), bigintval(postRequestParameter('to_userid')), bigintval(postRequestParameter('points')), postRequestParameter('reason'), $content['trans_id']), __FILE__, __LINE__);

				// Add points to account *directly* ...
				addPointsDirectly('member_transfer', bigintval(postRequestParameter('to_userid')), bigintval(postRequestParameter('points')));

				// ... and add it to current user's used points
				subtractPoints('transfer', getMemberId(), postRequestParameter('points'));

				// First send email to recipient
				$message = loadEmailTemplate('member_transfer_recipient', $content, postRequestParameter('to_userid'));
				sendEmail($content['recipient']['email'], '{--TRANSFER_MEMBER_RECIPIENT_SUBJECT--}' . ': ' . $SENDER, $message);

				// Second send email to sender
				$message = loadEmailTemplate('member_transfer_sender', $content, getMemberId());
				sendEmail($content['sender']['email'], '{--TRANSFER_MEMBER_SENDER_SUBJECT--}' . ': ' . $RECIPIENT, $message);

				// At last send admin mail(s)
				$adminSubject = sprintf("%s (%s->%s)", '{--TRANSFER_ADMIN_SUBJECT--}', $SENDER, $RECIPIENT);
				sendAdminNotification($adminSubject, 'admin_transfer_points', $content);

				// Transfer is completed
				loadTemplate('admin_settings_saved', false, '{--TRANSFER_COMPLETED--}' . '<br /><a href="{%url=modules.php?module=login&amp;what=transfer%}">{--TRANSFER_CONTINUE_OVERVIEW--}</a>');
			} elseif ($valid_code === false) {
				// Invalid Touring code!
				loadTemplate('admin_settings_saved', false, '<div class="member_note">{--TRANSFER_INVALID_CODE--}</div>');
				unsetPostRequestParameter('ok');
			} elseif ($valid_pass === false) {
				// Wrong password entered
				loadTemplate('admin_settings_saved', false, '<div class="member_note">{--TRANSFER_INVALID_PASSWORD--}</div>');
				unsetPostRequestParameter('ok');
			} elseif ($valid_amount === false) {
				// Too much points entered
				loadTemplate('admin_settings_saved', false, '<div class="member_note">{--TRANSFER_INVALID_POINTS--}</div>');
				unsetPostRequestParameter('ok');
			} elseif ($valid_reason === false) {
				// No transfer reason entered
				loadTemplate('admin_settings_saved', false, '<div class="member_note">{--TRANSFER_INVALID_REASON--}</div>');
				unsetPostRequestParameter('ok');
			} elseif ($valid_recipient === false) {
				// No recipient selected
				loadTemplate('admin_settings_saved', false, '<div class="member_note">{--TRANSFER_INVALID_RECIPIENT--}</div>');
				unsetPostRequestParameter('ok');
			} elseif ($valid_data === false) {
				// No recipient/sender selected
				loadTemplate('admin_settings_saved', false, '<div class="member_note">{--TRANSFER_INVALID_DATA--}</div>');
				unsetPostRequestParameter('ok');
			}

			// Free result
			SQL_FREERESULT($result);
		} // END - if

		if (!isFormSent()) {
			// Load member list
			if (isExtensionActive('nickname')) {
				// Load userid and nickname
				$result = SQL_QUERY_ESC("SELECT `userid`, `nickname` FROM `{?_MYSQL_PREFIX?}_user_data` WHERE `status`='CONFIRMED' AND `opt_in`='Y' AND `userid` != '%s' ORDER BY `userid` ASC",
					array(getMemberId()), __FILE__, __LINE__);
			} else {
				// Load only userid
				$result = SQL_QUERY_ESC("SELECT `userid`, `userid` FROM `{?_MYSQL_PREFIX?}_user_data` WHERE `status`='CONFIRMED' AND `opt_in`='Y' AND `userid` != '%s' ORDER BY `userid` ASC",
					array(getMemberId()), __FILE__, __LINE__);
			}

			if (!SQL_HASZERONUMS($result)) {
				// Load list
				$OUT  = '<select name="to_userid" size="1" class="member_select">
	<option value="0">{--SELECT_NONE--}</option>';
				// @TODO Try to rewrite his to $content = SQL_FETCHARRAY(), see some lines above for two different queries
				while (list($userid, $nick) = SQL_FETCHROW($result)) {
					$OUT .= '	<option value="' . $userid . '"';
					if ((isPostRequestParameterSet('to_userid')) && (postRequestParameter('to_userid') == $userid)) $OUT .= ' selected="selected"';
					$OUT .= '>';
					if (($nick != $userid) && (!empty($nick))) {
						// Output nickname
						$OUT .= $nick;
					} else {
						// Output userid
						$OUT .= $userid;
					}
					$OUT .= '</option>';
				}
				$OUT .= '</select>';
				$content['to_disabled'] = '';

				// Free memory
				SQL_FREERESULT($result);
			} else {
				// No one else is opt-in
				$OUT = loadTemplate('admin_settings_saved', true, '{--TRANSFER_NO_ONE_ELSE_OPT_IN--}');
				$content['to_disabled'] = ' disabled="disabled"';
			}

			// Transfer output to constant for the template
			$content['userid_selection'] = $OUT;

			// Generate Code
			if (getConfig('transfer_code') > 0) {
				$rand = mt_rand(0, 99999);
				$code = generateRandomCode(getConfig('transfer_code'), $rand, getMemberId(), $content['max_transferable']);
				$img = generateImageOrCode($code, false);
				$content['captcha_code'] = '<input type="hidden" name="code_chk" value="' . $rand . '" /><input type="text" name="code" class="member_normal" size="5" maxlength="7"' . $content['to_disabled'] . ' />&nbsp;' . $img;
			} else {
				$code = '00000';
				$content['captcha_code'] = loadTemplate('admin_settings_saved', true, '{--TRANSFER_NO_CODE--}');
			}

			// Init points/reason
			$content['points'] = '';
			$content['reason'] = '';

			// Transfer maybe already entered valued'
			if (isPostRequestParameterSet('ok')) {
				// Get values from form
				$content['points'] = postRequestParameter('points');
				$content['reason'] = postRequestParameter('reason');
			} // END - if

			// Output form
			loadTemplate('member_transfer_new', false, $content);
		} // END - if
		break;

	case 'list_in': // List only incoming transactions
	case 'list_out': // List only outgoing transactions
		// As you can see I put list_in and list_out together. I now do a switch() again on it for the right SQL command
		$nothingMessage = '';
		switch ($mode) {
			case 'list_in':
				$sql = "SELECT `trans_id`, `from_userid` AS party_userid, `points`, `reason`, `time_trans` FROM `{?_MYSQL_PREFIX?}_user_transfers_in` WHERE `userid`=%s ORDER BY `time_trans` DESC LIMIT {?transfer_max?}";
				$nothingMessage     = '{--TRANSFER_NO_INCOMING_TRANSFERS--}';
				$content['balance'] = '{--TRANSFER_TOTAL_INCOMING--}';
				$content['title']   = '{--TRANSFER_LIST_INCOMING--}';
				break;

			case 'list_out':
				$sql = "SELECT `trans_id`, `to_userid` AS party_userid, `points`, `reason`, `time_trans` FROM `{?_MYSQL_PREFIX?}_user_transfers_out` WHERE `userid`=%s ORDER BY `time_trans` DESC LIMIT {?transfer_max?}";
				$nothingMessage     = '{--TRANSFER_NO_OUTGOING_TRANSFERS--}';
				$content['balance'] = '{--TRANSFER_TOTAL_OUTGOING--}';
				$content['title']   = '{--TRANSFER_LIST_OUTGOING--}';
				break;
		} // END - switch

		// Run the SQL command and set total points to zero
		$totalPoints = '0';
		$result = SQL_QUERY_ESC($sql, array(getMemberId()), __FILE__, __LINE__);

		// Do we have entries?
		if (!SQL_HASZERONUMS($result)) {
			$OUT = '';
			// @TODO This should be somehow rewritten to $row = SQL_FETCHARRAY(), see switch() block above for SQL queries
			while (list($tid, $userid, $points, $reason, $stamp) = SQL_FETCHROW($result)) {
				// Rewrite points
				if ($type == 'OUT') $points = $points . '-';

				// Prepare content for template
				// @TODO Rewrite: tid->trans_id,stamp->time_trans
				$row = array(
					'trans_id' => $tid,
					'stamp'    => generateDateTime($stamp, 3),
					'userid'   => $userid,
					'reason'   => $reason,
					'points'   => $points
				);

				// Load row template
				$OUT .= loadTemplate('member_transfer_row2', true, $row);

				// Add points and switch color
				$totalPoints += $points;
			} // END - while

			// Free memory
			SQL_FREERESULT($result);
		} else {
			// Nothing for in or out
			$OUT = '<tr>
  <td colspan="5" align="center" class="bottom">
    ' . loadTemplate('admin_settings_saved', true, $nothingMessage) . '
  </td>
</tr>';
		}

		// ... and add them to a constant for the template
		$content['rows'] = $OUT;

		// Remeber total amount
		$content['total'] = translateComma($totalPoints);

		// Load final template
		loadTemplate('member_transfer_list', false, $content);
		break;

	case 'list_all': // List all transactions
		// We fill a temporary table with data from both tables. This is much easier
		// to code and unstand by you as sub-SELECT queries. I know this is not the
		// fastest way but it shall be fine for now.
		//
		// First of all create the temporary table
		$result = SQL_QUERY("CREATE TEMPORARY TABLE `{?_MYSQL_PREFIX?}_transfers_tmp` (
`trans_id` VARCHAR(12) NOT NULL DEFAULT '',
`party_userid` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`points` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`reason` VARCHAR(255) NOT NULL DEFAULT '',
`time_trans` VARCHAR(10) NOT NULL DEFAULT 0,
`trans_type` ENUM('IN','OUT') NOT NULL DEFAULT 'IN',
KEY (`party_userid`)
) TYPE=HEAP", __FILE__, __LINE__);

		// Let's begin with the incoming list
		$result = SQL_QUERY_ESC("SELECT `trans_id`, `from_userid`, `points`, `reason`, `time_trans` FROM `{?_MYSQL_PREFIX?}_user_transfers_in` WHERE `userid`=%s ORDER BY `id` ASC LIMIT {?transfer_max?}",
			array(getMemberId()), __FILE__, __LINE__);
		while ($DATA = SQL_FETCHROW($result)) {
			$DATA[] = 'IN';
			$DATA = implode("','", $DATA);
			$res_temp = SQL_QUERY("INSERT INTO `{?_MYSQL_PREFIX?}_transfers_tmp` (`trans_id`, `party_userid`, `points`, `reason`, `time_trans`, `trans_type`) VALUES ('" . $DATA . "')", __FILE__, __LINE__);
		} // END - while

		// Free memory
		SQL_FREERESULT($result);

		// As the last table transfer data from outgoing table to temporary
		$result = SQL_QUERY_ESC("SELECT `trans_id`, `to_userid`, `points`, `reason`, `time_trans` FROM `{?_MYSQL_PREFIX?}_user_transfers_out` WHERE `userid`=%s ORDER BY `id` LIMIT {?transfer_max?}",
			array(getMemberId()), __FILE__, __LINE__);
		while ($DATA = SQL_FETCHROW($result)) {
			$DATA[] = 'OUT';
			$DATA = implode("','", $DATA);
			$res_temp = SQL_QUERY("INSERT INTO `{?_MYSQL_PREFIX?}_transfers_tmp` (`trans_id`, `party_userid`, `points`, `reason`, `time_trans`, `trans_type`) VALUES ('" . $DATA . "')", __FILE__, __LINE__);
		} // END - while

		// Free memory
		SQL_FREERESULT($result);

		$total = '0';
		if (!SQL_HASZERONUMS($result)) {
			// Search for entries
			$result = SQL_QUERY("SELECT `party_userid`, `trans_id`, `points`, `reason`, `time_trans`, `trans_type` FROM `{?_MYSQL_PREFIX?}_transfers_tmp` ORDER BY `time_trans` DESC",
				__FILE__, __LINE__);

			// Output rows
			$OUT = '';
			while ($content = SQL_FETCHARRAY($result)) {
				// Rewrite points
				if ($content['trans_type'] == 'OUT') $content['points'] = '-'.$content['points']."";

				// Prepare content for template
				$content['time']   = generateDateTime($content['time_trans'], 3);
				$content['points'] = translateComma($content['points']);

				// Load row template
				$OUT .= loadTemplate('member_transfer_row', true, $content);

				// Add points and switch color
				$total += $content['points'];
			} // END - while

			// Free memory
			SQL_FREERESULT($result);
		} else {
			// Nothing for in and out
			$OUT = '<tr>
  <td colspan="5" align="center" class="bottom">
    ' . loadTemplate('admin_settings_saved', true, '{--TRANSFER_NO_INOUT_TRANSFERS--}') . '
  </td>
</tr>';
		}

		// ... and add them to a constant for the template
		$content['rows'] =  $OUT;

		// Remeber total amount
		$content['total'] = translateComma($total);

		// Set title
		$content['title'] = '{--TRANSFER_LIST_ALL--}';

		// Set "balance" word
		$content['balance'] = '{--TRANSFER_TOTAL_BALANCE--}';

		// At the end we don't need a temporary table in memory
		$result = SQL_QUERY("DROP TABLE IF EXISTS `{?_MYSQL_PREFIX?}_transfers_tmp`", __FILE__, __LINE__);

		// Load final template
		loadTemplate('member_transfer_list', false, $content);

		// Free some memory...
		SQL_FREERESULT($result);
		break;

	default: // Overview page
		// Check incoming transfers
		$total = countSumTotalData(getMemberId(), 'user_transfers_in', 'id', 'userid', true);
		$content['in_link'] = $total;
		if ($total > 0) {
			$content['in_link'] = '<a href="{%url=modules.php?module=login&amp;what=transfer&amp;mode=list_in%}">' . $total . '</a>';
		} // END - if

		// Check outgoing transfers
		$dmy = countSumTotalData(getMemberId(), 'user_transfers_out', 'id', 'userid', true);

		// Add to total amount
		$total += $dmy;

		$content['out_link'] = $dmy;
		if ($dmy > 0) {
			$content['out_link'] = '<a href="{%url=modules.php?module=login&amp;what=transfer&amp;mode=list_out%}">' . $dmy . '</a>';
		} // END - if

		// Total transactions
		$content['all_link'] = $total;
		if ($total > 0) {
			$content['all_link'] = '<a href="{%url=modules.php?module=login&amp;what=transfer&amp;mode=list_all%}">' . $total . '</a>';
		} // END - if

		if (isFormSent()) {
			// Save settings
			SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_user_data` SET `opt_in`='%s' WHERE `userid`=%s LIMIT 1",
				array(postRequestParameter('opt_in'), getMemberId()), __FILE__, __LINE__);

			// "Settings saved..."
			loadTemplate('admin_settings_saved', false, '<div class="member_done">{--SETTINGS_SAVED--}</div>');
		} // END - if

		// Init entries
		foreach (array('allow_y','allow_n') as $entry) {
			$content[$entry] = '';
		} // END - foreach

		// Set current selection
		$content['allow_' . strtolower(getUserData('opt_in'))] = ' checked="checked"';

		// Set 'new transfer' link according to above option
		switch (getUserData('opt_in')) {
			case 'Y':
				$content['new_link'] = '<a href="{%url=modules.php?module=login&amp;what=transfer&amp;mode=new%}" title="{--TRANSFER_NOW_TITLE--}">{--TRANSFER_NOW_LINK--}</a>';
				break;

			case 'N':
				$content['new_link'] = '{--TRANSFER_PLEASE_ALLOW_OPT_IN--}';
				break;
		} // END - switch

		// Check for latest out-transfers
		$result = SQL_QUERY_ESC("SELECT
	`time_trans`
FROM
	`{?_MYSQL_PREFIX?}_user_transfers_out`
WHERE
	`time_trans` > (UNIX_TIMESTAMP() - %s) AND `userid`=%s
ORDER BY
	`time_trans` DESC
LIMIT 1",
			array(
				getConfig('transfer_timeout'),
				getMemberId()
			), __FILE__, __LINE__);

		// Do we have an entry?
		if (SQL_NUMROWS($result) == 1) {
			// Load newest transaction
			list($newest) = SQL_FETCHROW($result);
			$content['settings'] = getMaskedMessage('TRANSFER_LATEST_IS', generateDateTime($newest, 3));
		} else {
			// Load template
			$content['settings'] = loadTemplate('member_transfer_settings', true, $content);
		}

		// Free result
		SQL_FREERESULT($result);

		// Load template
		loadTemplate('member_transfer_overview', false, $content);
		break;
} // END - switch

// [EOF]
?>
